Create a connector
https://{kibana_url}
- POST /api/actions/connector/{id}
- POST /s/{space_id}/api/actions/connector/{id}
Refer to Spaces for more information.
Path Parameters
-
idstring · min: 1 · max: 36required -
An identifier for the connector.
Request
-
connector_type_idstring · max: 64required -
The type of connector.
-
namestring · max: 1024required -
The display name for the connector.
-
configoneOf · default: {} -
The connector configuration details.
-
apiUrlstringrequired -
The Amazon Bedrock request URL.
-
regionstring -
Optional AWS region for request signing. Required when using a custom endpoint URL that does not include the region in the hostname (for example,
us-west-1). -
defaultModelstring · default: us.anthropic.claude-sonnet-4-5-20250929-v1:0 -
The generative artificial intelligence model for Amazon Bedrock to use. Current support is for the Anthropic Claude models.
-
urlstringrequired -
The CrowdStrike tenant URL. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
urlstringrequired -
The D3 Security API request URL. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
allowHtmlboolean · default: false -
When
true, the connector can send emails with HTML-formatted content in the body. Defaults tofalse. This option is unavailable whenserviceiselastic_cloud. -
clientIdstringnullable -
The client identifier, which is a part of OAuth 2.0 client credentials authentication, in GUID format. If
serviceisexchange_server, this property is required. -
fromstringrequired -
The from address for all emails sent by the connector. It must be specified in
user@host-nameformat. -
hasAuthboolean · default: true -
Specifies whether a user and password are required inside the secrets configuration.
-
hoststring -
The host name of the service provider. If the
serviceiselastic_cloud(for Elastic Cloud notifications) or one of Nodemailer's well-known email service providers, this property is ignored. Ifserviceisother, this property must be defined. -
oauthTokenUrlstringnullable -
portinteger -
The port to connect to on the service provider. If the
serviceiselastic_cloud(for Elastic Cloud notifications) or one of Nodemailer's well-known email service providers, this property is ignored. Ifserviceisother, this property must be defined. -
secureboolean -
Specifies whether the connection to the service provider will use TLS. If the
serviceiselastic_cloud(for Elastic Cloud notifications) or one of Nodemailer's well-known email service providers, this property is ignored. -
service -
The name of the email service.
-
Values:
elastic_cloudexchange_servergmailotheroutlook365ses -
tenantIdstringnullable -
The tenant identifier, which is part of OAuth 2.0 client credentials authentication, in GUID format. If
serviceisexchange_server, this property is required. -
apiUrlstringrequired -
The Google Gemini request URL.
-
defaultModelstring · default: gemini-2.5-pro -
The generative artificial intelligence model for Google Gemini to use.
-
gcpRegionstringrequired -
The GCP region where the Vertex AI endpoint enabled.
-
gcpProjectIDstringrequired -
The Google ProjectID that has Vertex AI endpoint enabled.
-
executionTimeFieldstring · default: nullnullable -
A field that indicates when the document was indexed.
-
indexstringrequired -
The Elasticsearch index to be written to.
-
refreshboolean · default: false -
The refresh policy for the write request, which affects when changes are made visible to search. Refer to the refresh setting for Elasticsearch document APIs.
-
apiUrlstringrequired -
The Jira instance URL.
-
projectKeystringrequired -
The Jira project key.
-
apiUrlstringrequired -
The OpenAI API endpoint.
-
apiUrlstringrequired -
The OpenAI API endpoint.
-
defaultModelstring -
The default model to use for requests.
-
apiUrlstringrequired -
The OpenAI-compatible API endpoint.
-
defaultModelstringrequired -
The default model to use for requests.
-
certificateDatastring · min: 1 -
PEM-encoded certificate content.
-
privateKeyDatastring · min: 1 -
PEM-encoded private key content.
-
caDatastring · min: 1 -
PEM-encoded CA certificate content.
-
verificationMode· default: full -
SSL verification mode for PKI authentication.
-
Values:
fullcertificatenone -
headersmap string to string -
Custom headers to include in requests.
-
apiUrlstringrequired -
The Opsgenie URL. For example,
https://api.opsgenie.comorhttps://api.eu.opsgenie.com. If you are using thexpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
apiUrlstringnullable -
The PagerDuty event URL.
-
urlstringrequired -
The SentinelOne tenant URL. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
apiUrlstringrequired -
The ServiceNow instance URL.
-
clientIdstring -
The client ID assigned to your OAuth application. This property is required when
isOAuthistrue. -
isOAuthboolean · default: false -
The type of authentication to use. The default value is false, which means basic authentication is used instead of open authorization (OAuth).
-
jwtKeyIdstring -
The key identifier assigned to the JWT verifier map of your OAuth application. This property is required when
isOAuthistrue. -
userIdentifierValuestring -
The identifier to use for OAuth authentication. This identifier should be the user field you selected when you created an OAuth JWT API endpoint for external clients in your ServiceNow instance. For example, if the selected user field is
Email, the user identifier should be the user's email address. This property is required whenisOAuthistrue. -
usesTableApiboolean · default: true -
Determines whether the connector uses the Table API or the Import Set API. This property is supported only for ServiceNow ITSM and ServiceNow SecOps connectors. NOTE: If this property is set to
false, the Elastic application should be installed in ServiceNow. -
apiUrlstringrequired -
The ServiceNow instance URL.
-
clientIdstring -
The client ID assigned to your OAuth application. This property is required when
isOAuthistrue. -
isOAuthboolean · default: false -
The type of authentication to use. The default value is false, which means basic authentication is used instead of open authorization (OAuth).
-
jwtKeyIdstring -
The key identifier assigned to the JWT verifier map of your OAuth application. This property is required when
isOAuthistrue. -
userIdentifierValuestring -
The identifier to use for OAuth authentication. This identifier should be the user field you selected when you created an OAuth JWT API endpoint for external clients in your ServiceNow instance. For example, if the selected user field is
Email, the user identifier should be the user's email address. This property is required whenisOAuthistrue. -
allowedChannelsobject -
A list of valid Slack channels.
-
apiUrlstringrequired -
The Swimlane instance URL.
-
appIdstringrequired -
The Swimlane application ID.
-
connectorTyperequired -
The type of connector. Valid values are
all,alerts, andcases. -
Values:
allalertscases -
mappingsobject -
The field mapping.
-
alertIdConfigobject -
Mapping for the alert ID.
-
caseIdConfigobject -
Mapping for the case ID.
-
caseNameConfigobject -
Mapping for the case name.
-
commentsConfigobject -
Mapping for the case comments.
-
descriptionConfigobject -
Mapping for the case description.
-
ruleNameConfigobject -
Mapping for the name of the alert's rule.
-
severityConfigobject -
Mapping for the severity.
-
organisationstring -
The organisation in TheHive that will contain the alerts or cases. By default, the connector uses the default organisation of the user account that created the API key.
-
urlstringrequired -
The instance URL in TheHive. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
urlstringrequired -
The Tines tenant URL. If you are using the
xpack.actions.allowedHostssetting, make sure this hostname is added to the allowed hosts. -
webhookIntegrationUrlstringrequired -
The endpoint URL of the Elastic Security integration in Torq.
-
accessTokenUrlstring -
The URL used to request an OAuth2 access token. If
hasAuthis set totrueandauthTypeiswebhook-oauth2-client-credentials, this property is required. -
additionalFieldsstringnullable -
Additional fields, encoded as a JSON object, sent as part of the OAuth2 access token request body.
-
authTypenullable -
The type of authentication to use: basic, SSL, OAuth2 client credentials, or none.
-
Values:
webhook-authentication-basicwebhook-authentication-sslwebhook-oauth2-client-credentials -
castring -
A base64 encoded version of the certificate authority file that the connector can trust to sign and validate certificates. This option is available for all authentication types.
-
certType -
If the
authTypeiswebhook-authentication-ssl, specifies whether the certificate authentication data is in a CRT and key file format or a PFX file format. -
Values:
ssl-crt-keyssl-pfx -
clientIdstring -
The client identifier for OAuth2 authentication. If
hasAuthis set totrueandauthTypeiswebhook-oauth2-client-credentials, this property is required. -
hasAuthboolean · default: true -
If true, a username and password for login type authentication must be provided.
-
headersobjectnullable -
A set of key-value pairs sent as headers with the request.
-
method· default: post -
The HTTP request method:
post,put,patch,get, ordelete. -
Values:
postputpatchgetdelete -
scopestring -
The scope requested when acquiring the OAuth2 access token.
-
urlstring -
The request URL. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
verificationMode· default: full -
Controls the verification of certificates. Use
fullto validate that the certificate has an issue date within thenot_beforeandnot_afterdates, chains to a trusted certificate authority (CA), and has a hostname or IP address that matches the names within the certificate. Usecertificateto validate the certificate and verify that it is signed by a trusted authority; this option does not check the certificate hostname. Usenoneto skip certificate validation. -
Values:
certificatefullnone -
authTypenullable -
The type of authentication to use: basic, SSL, OAuth2 client credentials, or none.
-
Values:
webhook-authentication-basicwebhook-authentication-sslwebhook-oauth2-client-credentials -
castring -
A base64 encoded version of the certificate authority file that the connector can trust to sign and validate certificates. This option is available for all authentication types.
-
certType -
If the
authTypeiswebhook-authentication-ssl, specifies whether the certificate authentication data is in a CRT and key file format or a PFX file format. -
Values:
ssl-crt-keyssl-pfx -
createCommentJsonstring -
A JSON payload sent to the create comment URL to create a case comment. You can use variables to add Kibana Cases data to the payload. The required variable is
case.comment. Due to Mustache template variables (the text enclosed in triple braces, for example,{{{case.title}}}), the JSON is not validated when you create the connector. The JSON is validated once the Mustache variables have been placed when the REST method runs. Manually ensure that the JSON is valid, disregarding the Mustache variables, so the later validation will pass. -
createCommentMethod· default: put -
The REST API HTTP request method to create a case comment in the third-party system. Valid values are
patch,post, andput. -
Values:
patchpostput -
createCommentUrlstring -
The REST API URL to create a case comment by ID in the third-party system. You can use a variable to add the external system ID to the URL. If you are using the
xpack.actions.allowedHosts setting, add the hostname to the allowed hosts. -
createIncidentJsonstringrequired -
A JSON payload sent to the create case URL to create a case. You can use variables to add case data to the payload. Required variables are
case.titleandcase.description. Due to Mustache template variables (which is the text enclosed in triple braces, for example,{{{case.title}}}), the JSON is not validated when you create the connector. The JSON is validated after the Mustache variables have been placed when REST method runs. Manually ensure that the JSON is valid to avoid future validation errors; disregard Mustache variables during your review. -
createIncidentMethod· default: post -
The REST API HTTP request method to create a case in the third-party system. Valid values are
patch,post, andput. -
Values:
patchpostput -
createIncidentResponseKeystringrequired -
The JSON key in the create external case response that contains the case ID.
-
createIncidentUrlstringrequired -
The REST API URL to create a case in the third-party system. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
getIncidentResponseExternalTitleKeystringrequired -
The JSON key in get external case response that contains the case title.
-
getIncidentUrlstringrequired -
The REST API URL to get the case by ID from the third-party system. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. You can use a variable to add the external system ID to the URL. Due to Mustache template variables (the text enclosed in triple braces, for example,{{{case.title}}}), the JSON is not validated when you create the connector. The JSON is validated after the Mustache variables have been placed when REST method runs. Manually ensure that the JSON is valid, disregarding the Mustache variables, so the later validation will pass. -
hasAuthboolean · default: true -
If true, a username and password for login type authentication must be provided.
-
headersmap string to stringnullable -
A set of key-value pairs sent as headers with the request URLs for the create case, update case, get case, and create comment methods.
-
updateIncidentJsonstringrequired -
The JSON payload sent to the update case URL to update the case. You can use variables to add Kibana Cases data to the payload. Required variables are
case.titleandcase.description. Due to Mustache template variables (which is the text enclosed in triple braces, for example,{{{case.title}}}), the JSON is not validated when you create the connector. The JSON is validated after the Mustache variables have been placed when REST method runs. Manually ensure that the JSON is valid to avoid future validation errors; disregard Mustache variables during your review. -
updateIncidentMethod· default: put -
The REST API HTTP request method to update the case in the third-party system. Valid values are
patch,post, andput. -
Values:
patchpostput -
updateIncidentUrlstringrequired -
The REST API URL to update the case by ID in the third-party system. You can use a variable to add the external system ID to the URL. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
verificationMode· default: full -
Controls the verification of certificates. Use
fullto validate that the certificate has an issue date within thenot_beforeandnot_afterdates, chains to a trusted certificate authority (CA), and has a hostname or IP address that matches the names within the certificate. Usecertificateto validate the certificate and verify that it is signed by a trusted authority; this option does not check the certificate hostname. Usenoneto skip certificate validation. -
Values:
certificatefullnone -
viewIncidentUrlstringrequired -
The URL to view the case in the external system. You can use variables to add the external system ID or external system title to the URL.
-
secretsoneOf · default: {} -
clientIdstringrequired -
The CrowdStrike API client identifier.
-
clientSecretstringrequired -
The CrowdStrike API client secret to authenticate the
clientId. -
tokenstringrequired -
The D3 Security token.
-
clientSecretstring -
The Microsoft Exchange Client secret for OAuth 2.0 client credentials authentication. It must be URL-encoded. If
serviceisexchange_server, this property is required. -
passwordstring -
The password for HTTP basic authentication. If
hasAuthis set totrue, this property is required. -
userstring -
The username for HTTP basic authentication. If
hasAuthis set totrue, this property is required. -
credentialsJsonstringrequired -
The service account credentials JSON file. The service account should have Vertex AI user IAM role assigned to it.
-
apiKeyIdstringrequired -
The authentication key ID for HTTP Basic authentication.
-
apiKeySecretstringrequired -
The authentication key secret for HTTP Basic authentication.
-
clientSecretstringrequired -
The client secret for your app in the Azure portal.
-
webhookUrlstringrequired -
The URL of the incoming webhook. If you are using the
xpack.actions.allowedHostssetting, add the hostname to the allowed hosts. -
apiKeystring -
The API key for authentication. For OpenAI and Azure OpenAI providers, it is required. For the
Otherprovider, it is required if you do not use PKI authentication. With PKI, you can also optionally include an API key if the OpenAI-compatible service supports or requires one. -
certificateDatastring · min: 1 -
Base64-encoded PEM certificate content for PKI authentication (Other provider only). Required for PKI.
-
privateKeyDatastring · min: 1 -
Base64-encoded PEM private key content for PKI authentication (Other provider only). Required for PKI.
-
caDatastring · min: 1 -
Base64-encoded PEM CA certificate content for PKI authentication (Other provider only). Optional.
-
apiKeystringrequired -
The Opsgenie API authentication key for HTTP Basic authentication.
-
routingKeystringrequired -
A 32 character PagerDuty Integration Key for an integration on a service.
-
tokenstringrequired -
The A SentinelOne API token.
-
clientSecretstring -
The client secret assigned to your OAuth application. This property is required when
isOAuthistrue. -
passwordstring -
The password for HTTP basic authentication. This property is required when
isOAuthisfalse. -
privateKeystring -
The RSA private key that you created for use in ServiceNow. This property is required when
isOAuthistrue. -
privateKeyPasswordstring -
The password for the RSA private key. This property is required when
isOAuthistrueand you set a password on your private key. -
usernamestring -
The username for HTTP basic authentication. This property is required when
isOAuthisfalse. -
tokenstringrequired -
Slack bot user OAuth token.
-
apiTokenstring -
Swimlane API authentication token.
-
apiKeystringrequired -
The API key for authentication in TheHive.
-
tokenstringrequired -
The secret of the webhook authentication header.
-
clientSecretstring -
The client secret for OAuth2 authentication. If
hasAuthis set totrueandauthTypeiswebhook-oauth2-client-credentials, this property is required. -
crtstring -
If
authTypeiswebhook-authentication-sslandcertTypeisssl-crt-key, it is a base64 encoded version of the CRT or CERT file. -
keystring -
If
authTypeiswebhook-authentication-sslandcertTypeisssl-crt-key, it is a base64 encoded version of the KEY file. -
pfxstring -
If
authTypeiswebhook-authentication-sslandcertTypeisssl-pfx, it is a base64 encoded version of the PFX or P12 file. -
passwordstring -
The password for HTTP basic authentication or the passphrase for the SSL certificate files. If
hasAuthis set totrueandauthTypeiswebhook-authentication-basic, this property is required. -
userstring -
The username for HTTP basic authentication. If
hasAuthis set totrueandauthTypeiswebhook-authentication-basic, this property is required. -
crtstring -
If
authTypeiswebhook-authentication-sslandcertTypeisssl-crt-key, it is a base64 encoded version of the CRT or CERT file. -
keystring -
If
authTypeiswebhook-authentication-sslandcertTypeisssl-crt-key, it is a base64 encoded version of the KEY file. -
pfxstring -
If
authTypeiswebhook-authentication-sslandcertTypeisssl-pfx, it is a base64 encoded version of the PFX or P12 file. -
passwordstring -
The password for HTTP basic authentication. If
hasAuthis set totrueand andauthTypeiswebhook-authentication-basic, this property is required. -
userstring -
The username for HTTP basic authentication. If
hasAuthis set totrueandauthTypeiswebhook-authentication-basic, this property is required. -
passwordstring -
A user name for HTTP basic authentication. It is applicable only when
usesBasicistrue. -
secretsUrlstring -
The request URL for the Elastic Alerts trigger in xMatters with the API key included in the URL. It is applicable only when
usesBasicisfalse. -
userstring -
A password for HTTP basic authentication. It is applicable only when
usesBasicistrue.
Defines properties for connectors when type is .bedrock.
Defines config properties for connectors when type is .crowdstrike.
Defines properties for connectors when type is .d3security.
Defines properties for connectors when type is .email.
Defines properties for connectors when type is .gemini.
Defines properties for connectors when type is .resilient.
Defines properties for connectors when type is .index.
Defines properties for connectors when type is .jira.
Defines properties for connectors when type is .gen-ai and the API provider is Azure OpenAI.
Defines properties for connectors when type is .gen-ai and the API provider is OpenAI.
Defines properties for connectors when type is .gen-ai and the API provider is Other (OpenAI-compatible service), including optional PKI authentication.
Defines properties for connectors when type is .opsgenie.
Defines properties for connectors when type is .pagerduty.
Defines properties for connectors when type is .sentinelone.
Defines properties for connectors when type is .servicenow.
Defines properties for connectors when type is .servicenow-itom.
Defines properties for connectors when type is .slack_api.
Defines properties for connectors when type is .swimlane.
Defines configuration properties for connectors when type is .thehive.
Defines properties for connectors when type is .tines.
Defines properties for connectors when type is .torq.
Defines properties for connectors when type is .webhook.
Defines properties for connectors when type is .cases-webhook.
Defines properties for connectors when type is .xmatters.
Defines secrets for connectors when type is .bedrock.
Defines secrets for connectors when type is .crowdstrike.
Defines secrets for connectors when type is .d3security.
Defines secrets for connectors when type is .email.
Defines secrets for connectors when type is .gemini.
Defines secrets for connectors when type is .resilient.
Defines secrets for connectors when type is .jira.
Defines secrets for connectors when type is ..microsoft_defender_endpoint.
Defines secrets for connectors when type is .teams.
Defines secrets for connectors when type is .gen-ai. Supports both API key authentication (OpenAI, Azure OpenAI, and Other) and PKI authentication (Other provider only). PKI fields must be base64-encoded PEM content.
Defines secrets for connectors when type is .opsgenie.
Defines secrets for connectors when type is .pagerduty.
Defines secrets for connectors when type is .sentinelone.
Defines secrets for connectors when type is .servicenow, .servicenow-sir, or .servicenow-itom.
Defines secrets for connectors when type is .slack.
Defines secrets for connectors when type is .swimlane.
Defines secrets for connectors when type is .thehive.
Defines secrets for connectors when type is .tines.
Defines secrets for connectors when type is .torq.
Defines secrets for connectors when type is .webhook.
Defines secrets for connectors when type is .xmatters.
Responses
Indicates a successful call.
-
configmap string to object -
connector_type_idstringrequired -
The connector type identifier.
-
idstringrequired -
The identifier for the connector.
-
is_connector_type_deprecatedbooleanrequired -
Indicates whether the connector type is deprecated.
-
is_deprecatedbooleanrequired -
Indicates whether the connector is deprecated.
-
is_missing_secretsboolean -
Indicates whether the connector is missing secrets.
-
is_preconfiguredbooleanrequired -
Indicates whether the connector is preconfigured. If true, the
configandis_missing_secretsproperties are omitted from the response. -
is_system_actionbooleanrequired -
Indicates whether the connector is used for system actions.
-
namestringrequired -
The name of the connector.
Indicates that this call is forbidden.